<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DataSource\DataSet;
use Util\InstanceProvider;

class TaskReplanningReason
{
    public function findTaskReplanningReason(Request\Filter $request, Response $response)
    {
        try {
            $conditions = $request->getFilterCriteria()->getConditions();
            $taskReplanningReasonService = InstanceProvider::getService()->getTaskReplanningReason();
            $taskReplanningReason = $taskReplanningReasonService->findTaskReplanningReason($conditions);
            $response->addDataset(new DataSet('taskReplanningReason', $taskReplanningReason));
        } catch (\Exception $e) {
            throw new \Exception($e->getMessage() . ' Code:' . $e->getCode());
        }
    }
    
    public function needTaskReplanningReason(Request\filter $request, Response $response)
    {
        try {
            $taskReplanningReasonService = InstanceProvider::getService()->getTaskReplanningReason();
            $conditions = $request->getFilterCriteria()->getConditions();
            $originProjectId = $conditions[0]['value'];
            $needTaskReplanningReason = $taskReplanningReasonService->needTaskReplanningReason($originProjectId);
            $response->addDataset(new DataSet('needTaskReplanningReason', [$needTaskReplanningReason]));
        } catch (\Exception $ex) {
            $response->setError(new Response\Error($ex->getMessage(), $ex->getCode()));
            $response->addMessage(new Response\Message($ex->getMessage(), Response\Message::TYPE_WARNING));
        }
            
    }
}