DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    /*REGISTRANDO A PROCEDURE PARA O AGENDADOR DE EVENTOS*/
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV 
    WHERE  NMOBJBDEVEN = 'ETL_MERENDA';
    
    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
        
            SELECT LPAD(NVL(MAX(CDEVENTOAEV)+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;
        
            INSERT INTO EVENTOAEV 
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'ETL Faturamento Comissaria','STP',NULL,SYSDATE,'ETL_MERENDA');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');
            
            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN) 
            VALUES
            (V_CDSEQUENCIAL,'P_DTFINA','D','E','Data Final','N',0,'02');
        
            COMMIT;
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    END IF;
END;
/


begin
   CRIA_FATOS('ETL_RESUFOOD', 'VRCUSPLAETLFOO1',   'Custo Planejado 1', 'Planejamento');
   CRIA_FATOS('ETL_RESUFOOD', 'VRCUSPLAETLFOO2',   'Custo Planejado 2', 'Planejamento');
   CRIA_FATOS('ETL_RESUFOOD', 'VRCUSPLAETLFOO3',   'Custo Planejado 3', 'Planejamento');
   CRIA_FATOS('ETL_RESUFOOD', 'VRCUSREAETLFOO1',   'Custo Realizado 1', 'Planejamento');
   CRIA_FATOS('ETL_RESUFOOD', 'VRCUSREAETLFOO2',   'Custo Realizado 2', 'Planejamento');
   CRIA_FATOS('ETL_RESUFOOD', 'VRCUSREAETLFOO3',   'Custo Realizado 3', 'Planejamento');

   CRIA_DIME('ETL_RESUFOOD',  'CDSUPERVISOR',   'Supervisor',           'SUPERVISOR',    'CDSUPERVISOR',   'NMSUPERVISOR', NULL); 
   CRIA_DIME('ETL_RESUFOOD',  'CDGOPERAC',      'Gerente Operacional',  'GOPERAC',       'CDGOPERAC',      'NMGOPERAC',    NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'CDGRUPSERV',     'Grupo de servios',    'GRUPSERV',      'CDGRUPSERV',     'NMGRUPSERV',   NULL);       
   CRIA_DIME('ETL_RESUFOOD',  'CDFILIAL',       'Filial',               'FILIAL',        'CDFILIAL',       'NMFILIAL',     NULL); 
   CRIA_DIME('ETL_RESUFOOD',  'CDEMPRESA',      'Empresa',              'EMPRESA',       'CDEMPRESA',      'NMEMPRESA',    NULL); 
   CRIA_DIME('ETL_RESUFOOD',  'CDAREAGERE',     'Regional',             'AREAGERE',      'CDAREAGERE',     'NMAREAGERE',   NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'CDSEGMER',       'Segmento de Mercado',  'SEGMERCADO',    'CDSEGMER',       'DSSEGMER',     NULL);       
   CRIA_DIME('ETL_RESUFOOD',  'CDFILISERVFILI', 'Servio',              'FILISERVFILI',  'CDFILISERVFILI', 'NMSERVICO',    NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'CDPRODUTO',      'Produto',              'PRODUTO',       'CDPRODUTO',      'NMPRODUTO',    NULL);       
   CRIA_DIME('ETL_RESUFOOD',  'ANETLFOOD',      'Ano',                   NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'MEETLFOOD',      'Ms',                   NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'BIETLFOOD',      'BImestre',              NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'TRETLFOOD',      'Trimestre',             NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUFOOD',  'SEETLFOOD',      'Semestre',              NULL,            NULL,             NULL,          NULL);       


   CRIA_FATOS('ETL_RESUSERV', 'QTCOMESTETLSERV',   'Qtd. Comensais Estimados', 'Planejamento');
   CRIA_FATOS('ETL_RESUSERV', 'QTCOMEFEETLSERV',   'Qtd. Comensais Efetivos',  'Planejamento');
   CRIA_FATOS('ETL_RESUSERV', 'VRCUSPADETLSERV',   'Custo Padro do Servio',  'Planejamento');

   CRIA_DIME('ETL_RESUSERV',  'CDSUPERVISOR',   'Supervisor',           'SUPERVISOR',    'CDSUPERVISOR',   'NMSUPERVISOR', NULL); 
   CRIA_DIME('ETL_RESUSERV',  'CDGOPERAC',      'Gerente Operacional',  'GOPERAC',       'CDGOPERAC',      'NMGOPERAC',    NULL);    
   CRIA_DIME('ETL_RESUSERV',  'CDGRUPSERV',     'Grupo de servios',    'GRUPSERV',      'CDGRUPSERV',     'NMGRUPSERV',   NULL);       
   CRIA_DIME('ETL_RESUSERV',  'CDFILIAL',       'Filial',               'FILIAL',        'CDFILIAL',       'NMFILIAL',     NULL); 
   CRIA_DIME('ETL_RESUSERV',  'CDEMPRESA',      'Empresa',              'EMPRESA',       'CDEMPRESA',      'NMEMPRESA',    NULL); 
   CRIA_DIME('ETL_RESUSERV',  'CDAREAGERE',     'Regional',             'AREAGERE',      'CDAREAGERE',     'NMAREAGERE',   NULL);    
   CRIA_DIME('ETL_RESUSERV',  'CDSEGMER',       'Segmento de Mercado',  'SEGMERCADO',    'CDSEGMER',       'DSSEGMER',     NULL);       
   CRIA_DIME('ETL_RESUSERV',  'CDFILISERVFILI', 'Servio',              'FILISERVFILI',  'CDFILISERVFILI', 'NMSERVICO',    NULL);    
   CRIA_DIME('ETL_RESUSERV',  'ANETLSERV',      'Ano',                   NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUSERV',  'MEETLSERV',      'Ms',                   NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUSERV',  'BIETLSERV',      'BImestre',              NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUSERV',  'TRETLSERV',      'Trimestre',             NULL,            NULL,             NULL,          NULL);    
   CRIA_DIME('ETL_RESUSERV',  'SEETLSERV',      'Semestre',              NULL,            NULL,             NULL,          NULL);       

   commit;
end;
/
   
