<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Entities;

use Service\Calendar\Precursor\Strategy\PrecursorFactory;
use Service\Calendar\TaskRelationshipInterface;
use Zeedhi\DevOps\Model\Util\LogicalDeletedInRelationship;
use Zeedhi\DevOps\Util\Events\Audit_with_id\AuditAble;
use Zeedhi\DevOps\Util\Events\Organization_with_id\OrganizationAble;


class TaskRelationship
    extends Base\TaskRelationship
    implements AuditAble, OrganizationAble, LogicalDeletedInRelationship  {

    const PRECURSOR_TYPE = 'P';
    const RELATIONSHIP_ISSUE_TYPE = 'I';
    const ISSUE_WITH_ISSUE_TYPE = 'U';
    const ORIGIN_TYPE = 'O';
    const SCHEDULE_TYPE = 'S';
    const RELATED_TASK_TYPE = 'A';
    const TASK_WITH_SCHEDULE_TYPE = 'W';

    const CONFLICT_TYPE = 'C';
    const CONFLICT_DEVOPS_TYPE = 'D';
    const ERROR_TYPE = 'E';
    const ERROR_MR_TYPE = 'G';
    const TEST_TYPE = 'T';
    const MERGE_REQUEST_TYPE = 'M';
    const REPLICATION_TYPE = 'R';
    const END_START_TYPE = 'TI';

    const FIRST_TYPE = 'F';
    const BASELINE_TYPE = 'B';

    public static function getAllTypesForMergeDescription(){

        return array(
            self::CONFLICT_TYPE,
            self::CONFLICT_DEVOPS_TYPE,
            self::ERROR_TYPE,
            self::ERROR_MR_TYPE,
            self::TEST_TYPE,
            self::MERGE_REQUEST_TYPE,
            self::ORIGIN_TYPE,
        );
    }
    public static function getAllTypesInSameProject(){

        return array(
            self::CONFLICT_TYPE,
            self::ERROR_MR_TYPE,
            self::MERGE_REQUEST_TYPE,
        );
    }

    public static function getFilterLogicalDeletedInRelationship($targetTableAlias){
        return " NOT EXISTS (SELECT id FROM TASK WHERE (ID = $targetTableAlias.TASK OR ID = $targetTableAlias.TASK_RELATIONSHIP) AND STATUS = 'D' ) ";
    }
}